"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint max-params: ["error", 6] */
/* eslint-env es6 */
const crunchWeeks = (issuesTree, node, closedIssues, emptyCalendar) => {
    return issuesTree.treeToArray(node).reduce((acc, item) => {
        const issueExist = closedIssues.find(i => i.key === item.key);
        return acc.map((week) => {
            if (issueExist !== undefined && week.weekStart === issueExist.weekStart) {
                // if (issueExist.key === 'BACKLOG-11527') {
                //   console.log(week.weekTxt);
                //   console.log(issueExist);
                // }
                const issuesWeeks = [...week.list, issueExist];
                let weeklyPoints = week.points.count;
                // If current issue contains points, re-calculate weekly totals
                if (issueExist.points !== undefined && issueExist.points !== null) {
                    weeklyPoints = issuesWeeks
                        .filter((issue) => issue.points !== undefined && issue.points !== null)
                        .map((issue) => issue.points)
                        .reduce((acc, points) => acc + points, 0);
                }
                return Object.assign(Object.assign({}, week), { list: issuesWeeks, issues: { count: issuesWeeks.length }, points: { count: weeklyPoints } });
            }
            return week;
        });
    }, emptyCalendar);
};
exports.default = crunchWeeks;
