"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
    This function creates an empty object containing all of the expected days and weeks between the passed dats with zeroed values
*/
const date_fns_1 = require("date-fns");
const dateUtils_1 = require("../misc/dateUtils");
const getEmptyCalendar = (issues) => {
    // Sort the array by closedAt
    issues.sort((a, b) => a.closedAt > b.closedAt ? 1 : b.closedAt > a.closedAt ? -1 : 0);
    const emptyWeeks = [];
    const currentDate = dateUtils_1.formatDate(issues[0].closedAt);
    while (currentDate < dateUtils_1.formatDate(issues[issues.length - 1].closedAt)) {
        const weekEnd = date_fns_1.formatISO(date_fns_1.endOfWeek(currentDate), {
            representation: 'date',
        });
        const weekTxt = date_fns_1.getYear(date_fns_1.endOfWeek(currentDate)) + '.' + date_fns_1.getWeek(currentDate);
        if (emptyWeeks.find((week) => week.weekTxt === weekTxt) === undefined) {
            emptyWeeks.push({
                list: [],
                issues: { count: 0 },
                points: { count: 0 },
                weekStart: date_fns_1.formatISO(date_fns_1.startOfWeek(currentDate), {
                    representation: 'date',
                }),
                weekEnd: weekEnd,
                weekTxt,
            });
        }
        currentDate.setDate(currentDate.getDate() + 1);
    }
    return emptyWeeks;
};
exports.default = getEmptyCalendar;
