"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const crunchMetrics_1 = require("./crunchMetrics");
const crunchWeeks_1 = require("./crunchWeeks");
/* eslint max-params: ["error", 6] */
/* eslint-env es6 */
const prepareInitiativesData = (issuesTree, node, level, closedIssues, emptyCalendar, userConfig) => {
    if (node.key !== undefined) {
        node.level = level;
        node.metrics = crunchMetrics_1.default(issuesTree, node);
        node.isLeaf = !issuesTree.hasChildren(node);
        node.weeks = crunchWeeks_1.default(issuesTree, node, closedIssues, emptyCalendar);
    }
    for (const children of issuesTree.childrenIterator(node)) {
        prepareInitiativesData(issuesTree, children, level + 1, closedIssues, emptyCalendar, userConfig);
    }
    return [];
};
exports.default = prepareInitiativesData;
