"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const date_fns_1 = require("date-fns");
/*
    Returns an array of all days between two dates
*/
exports.getDaysBetweenDates = (startDate, endDate) => {
    const days = [];
    const currentDate = startDate;
    // eslint-disable-next-line no-unmodified-loop-condition
    while (currentDate < endDate) {
        let currentMonthDay = currentDate.getDate();
        if (currentDate.getDay() !== 0) {
            currentMonthDay -= currentDate.getDay();
        }
        const currentWeekYear = new Date(currentDate.getFullYear(), currentDate.getMonth(), currentMonthDay);
        currentWeekYear.setUTCHours(0);
        const actualDate = new Date(currentDate);
        actualDate.setUTCHours(0);
        days.push({
            date: actualDate,
            weekStart: date_fns_1.formatISO(date_fns_1.startOfWeek(actualDate), {
                representation: 'date',
            }),
            weekEnd: date_fns_1.formatISO(date_fns_1.endOfWeek(actualDate), {
                representation: 'date',
            }),
            weekTxt: date_fns_1.getYear(actualDate) + '.' + date_fns_1.getWeek(actualDate),
        });
        currentDate.setDate(currentDate.getDate() + 1);
    }
    return days;
};
/*
    Takes a date string and returns a date mid-day
*/
exports.formatDate = (dateString) => {
    const day = new Date(dateString);
    day.setUTCHours(12);
    day.setUTCMinutes(0);
    day.setUTCSeconds(0);
    return day;
};
