"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
    This function add details about the open issues
*/
const insertOpen = (calendar, issues) => {
    const updatedCalendar = JSON.parse(JSON.stringify(calendar));
    const remainingPoints = issues
        .filter((issue) => issue.points !== undefined)
        .map((issue) => issue.points)
        .reduce((acc, points) => acc + points, 0);
    updatedCalendar.open = {
        issues: { count: issues.length },
        points: { count: remainingPoints },
        list: issues,
    };
    return updatedCalendar;
};
exports.default = insertOpen;
